%define name		jasper5
%define full_name	jakarta-%{name}
%define version		5.0.19
%define majversion	5.0
%define release		1jpp
%define section		free

%define summary		Apache JSP Engine, RI for Servlet JSP 2.0 API
%define license		Apache Software License
%define distribution	JPackage
%define vendor		JPackage Project

%define jname		jasper5
%define tcuid		91

%define packname 	jakarta-tomcat-%{version}
%define packdname	jakarta-tomcat-%{version}-src
%define jpackdname	jakarta-tomcat-connectors-%{version}-src

# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
%define confdir		%{_sysconfdir}/%{name}
%define logdir		%{_localstatedir}/log/%{name}
%define homedir		%{_datadir}/%{name}
%define bindir		%{_datadir}/%{name}/bin
%define tempdir		%{_localstatedir}/cache/%{name}/temp
%define workdir		%{_localstatedir}/cache/%{name}/work
%define appdir		%{_localstatedir}/lib/%{name}/webapps
%define serverdir	%{_localstatedir}/lib/%{name}/server
%define commondir	%{_localstatedir}/lib/%{name}/common
%define shareddir	%{_localstatedir}/lib/%{name}/shared

Summary: 		%{summary}
Name: 			%{name}
Version: 		%{version}
Release: 		%{release}
Epoch:			0
License:		%{license}
Vendor:			%{vendor}
Distribution:		%{distribution}
Group: 			Development/Compilers
URL: 			http://jakarta.apache.org/tomcat/
BuildArch: 		noarch
Source:			http://jakarta.apache.org/builds/jakarta-tomcat-5.0/release/v%{version}/src/%{packdname}.tar.gz

Patch0:			jasper5_command.patch
BuildRoot:		%{_tmppath}/%{name}-root-%{version}

Requires:	   ant >= 0:1.5.4, jpackage-utils >= 0:1.5.32
Requires:          servletapi5 >= 0:5.0.18
Requires:          xerces-j2 >= 0:2.6.0
Requires:          xml-commons-apis >= 0:1.0
Requires:          jakarta-commons-el >= 0:1.0
Requires:          jakarta-commons-collections >= 0:2.1
Requires:          jakarta-commons-logging >= 0:1.0.3
Requires:          jakarta-commons-daemon >= 0:1.0

Buildrequires:		jpackage-utils >= 0:1.5.32
BuildRequires:		ant >= 0:1.5.4, ant-optional >= 0:1.5.4
BuildRequires:          servletapi5 >= 0:5.0.18
BuildRequires:          servletapi5-javadoc >= 0:5.0.18
BuildRequires:          xerces-j2 >= 0:2.6.0
BuildRequires:          xml-commons-apis >= 0:1.0
BuildRequires:          jakarta-commons-el >= 0:1.0
BuildRequires:          jakarta-commons-collections >= 0:2.1
BuildRequires:          jakarta-commons-logging >= 0:1.0.3
BuildRequires:          jakarta-commons-daemon >= 0:1.0

%description
JSP engine that conforms to the JSP 2.0
specifications from Java Software.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.


%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0

cd %{packdname}
%patch0

%build
export CLASSPATH=%(build-classpath xml-commons-apis xalan-j2 servletapi4)

# Remove pre-build jars
for dir in %{packdname} ; do
    find $dir -name "*.jar" -exec rm -f {} \;
done

# build jasper 5
cd %{packdname}
pushd jakarta-tomcat-jasper/jasper2

cat > build.properties <<EOBP
ant.jar=$(build-classpath ant)
servlet-api.jar=$(build-classpath servletapi5)
jsp-api.jar=$(build-classpath jspapi)
tools.jar=%{java.home}/lib/tools.jar
xerces.jar=$(build-classpath xerces-j2)
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xmlParserAPIs.jar=$(build-classpath xml-commons-apis)
commons-el.jar=$(build-classpath commons-el)
commons-collections.jar=$(build-classpath commons-collections)
commons-logging.jar=$(build-classpath commons-logging)
commons-daemon.jar=$(build-classpath commons-daemon)
junit.jar=$(build-classpath junit)

EOBP

# can't use jikes to build tomcat4 (strange)
ant -Djava.home=%{java_home} -Dbuild.compiler=modern javadoc

#sed -e 's|tomcat|jasper|g' -e 's|TOMCAT|JASPER|g' build/bin/jasper.sh > build/bin/jasper.sh.mod
#cp build/bin/jasper.sh.mod build/bin/jasper.sh
 
popd


%install
rm -rf $RPM_BUILD_ROOT

cd %{packdname}
# bins
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install jakarta-tomcat-jasper/jasper2/build/bin/jspc.sh \
                                    $RPM_BUILD_ROOT%{_bindir}/jspc5.sh
install jakarta-tomcat-jasper/jasper2/build/bin/jasper.sh \
                                    $RPM_BUILD_ROOT%{_bindir}/jasper5.sh
install jakarta-tomcat-catalina/catalina/src/bin/setclasspath.sh \
		      $RPM_BUILD_ROOT%{_bindir}/jasper5_classpath.sh
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install jakarta-tomcat-jasper/jasper2/build/shared/lib/jasper-compiler.jar \
                     $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler-%{version}.jar
ln -s %{name}-compiler-%{version}.jar \
                     $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler.jar
install jakarta-tomcat-jasper/jasper2/build/shared/lib/jasper-runtime.jar \
                     $RPM_BUILD_ROOT%{_javadir}/%{name}-runtime-%{version}.jar
ln -s %{name}-runtime-%{version}.jar \
                     $RPM_BUILD_ROOT%{_javadir}/%{name}-runtime.jar
# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr jakarta-tomcat-jasper/jasper2/build/javadoc/* \
                     $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} \
                     $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# FHS compliance patches, not easy to track them all boys :)
#
#i=$RPM_BUILD_ROOT%{_bindir}/jasper5.sh
#perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
#perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
#perl -pi -e "s|\@\@\@TCBIN\@\@\@|%{bindir}|g;" $i
#perl -pi -e "s|\@\@\@TCCOMMON\@\@\@|%{commondir}|g;" $i
#perl -pi -e "s|\@\@\@TCSERVER\@\@\@|%{serverdir}|g;" $i
#perl -pi -e "s|\@\@\@TCSHARED\@\@\@|%{shareddir}|g;" $i
#perl -pi -e "s|\@\@\@TCAPP\@\@\@|%{appdir}|g;" $i
#perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(644,root,root,755)
%doc %{packdname}/jakarta-tomcat-5/{LICENSE,RELE*,RUNNING.txt,BENCHMARKS.txt}
%doc %{packdname}/jakarta-tomcat-jasper/jasper2/doc/jspc.html
%{_javadir}/*.jar
%attr(755,root,root)            %{_bindir}/*.sh


%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Wed Feb 25 2004 Kaj J. Niemi <kajtzu@a51.org> 0:5.0.19-1jpp
- Update to 5.0.19

* Wed Jan 28 2004 Ralph Apel <r.apel@r-apel.de> 0:5.0.18-1jpp
- derived this separate package from tomcat5-5.0.18-1jpp
- its purpose is to provide standalone jasper5-runtime and jasper5-compiler
  as well as jasper5-javadoc
- Jakarta original style jasper5.sh and jspc5.sh are included
- doesn't conflict with tomcat5 <= 0:5.0.18
